import create from 'dd-store';
import { checkFullScren } from "../../utils/checkFullScren";
import pageStore from './store';
import { saveFileInfo, getMeetingRoomAffairs, createMeetingTask, deleteMeetingTask, updateMeetingTask, uploadPermissions } from '../../api/request';
import { getOssPermission, getuploadResource, isParticipate, deleteSchedule, getScheduleDetail, getUserScheduleInTime, modifySchedule, getMeetingRoomRepeatAffairs } from '../../api/request.js'
import { throttle, getCreateShowTime } from './../../utils/utils.js'
import { observer } from '/utils/observer.js'
import { resolve } from 'path';
import { getFileInfoFromOss } from './uploadFile';
import { comShareData } from './const.js';
create.Page({
  store: pageStore,
  useAll: true,
  data: {
    current: 1,
    pages: 1,
    isIPX: false,
    $data: null,
    affairLoading: true,
    affairList: null, //store,页面用到的变量需要在这里声明
    show: false, //pop
    oldTask: null,
    pop: {
      title: '',
      type: ''
    },
    loading: false,
    // 传给组件list 的所有数据 comListData
    comListData: {
      repeatList: [
        { id: 0, text: '不重复', icon: 'iconicon_cycle', repeatable: 0, recurrenceModel: { model: 'no_repeat' } },
        { id: 1, text: '每天', icon: '', repeatable: 1, recurrenceModel: { model: 'daily', interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: null } },
        { id: 2, text: '每周', icon: '', repeatable: 1, recurrenceModel: { model: 'weekly', interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: ['MO'] } },
        { id: 3, text: '每周的工作日', icon: '', repeatable: 1, recurrenceModel: { model: 'weekly', interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: ['MO', 'TU', 'WE', 'TH', 'FR'] } },
        { id: 4, text: '每月', icon: '', repeatable: 1, recurrenceModel: { model: 'absolute_Monthly', daysOfMonth: ['23'], interval: 1, initialTime: `2020-03-23`, terminateTime: `2022-03-23`, weekDayList: null } }
      ],
      meetingWayList: [
        { id: 0, text: '钉钉', imageUrl: '../../assests/dingding.png', meetingWayModel: { model: 'dingtalk' } },
        { id: 1, text: 'Zoom Meeting', imageUrl: '../../assests/Zoom.png', meetingWayModel: { model: 'zoom' } }
      ],
      aheadTimesList: [
        { id: -1, text: '不提醒', icon: 'iconicon_cycle' },
        { id: 0, text: '会议开始时提醒', icon: '' },
        { id: 5, text: '提前5分钟提醒', icon: '' },
        { id: 15, text: '提前15分钟提醒', icon: '' },
        { id: 30, text: '提前30分钟提醒', icon: '' },
        { id: 60, text: '提前一小时提醒', icon: '' },
        { id: 120, text: '提前二小时提醒', icon: '' },
        { id: 1440, text: '提前一天提醒', icon: '' },
        { id: 105120, text: '提前一周提醒', icon: '' }
      ],
      multiple: false,
      complete: false,
      aheadTimesListId: [15],
      comSelectListId: 0,
      meetingWayModelId: null,
      iconType: 'icon'
    },
    // 传给组件 hList 水平排列  所有数据 comHListData
    comHListData: {
      contactData: [
        { id: 0, text: '钉钉联系人', imageUrl: '../../assests/dingContact.png' },
        { id: 1, text: '手动添加邮箱', imageUrl: '../../assests/emailContact.png' }
      ]
    },
    // 传递给组件toast的所有数据
    conToastData: {
      showToast: false,
      title: '保存成功'
    },
    // 传递给组件selectPopup 的数据
    conSelectPopupData: {
      showSelectPopup: false,
      selectType: 'common',
      selectPopupId: '',
      editSaveList: [{ text: '仅保存此会议', id: 'only' }, { text: '保存此次及以后会议', id: 'future' }],
      delSheudleList: [{ text: '仅删除此会议', id: 'only' }, { text: '删除此次及以后会议', id: 'future' }],
      participateStatusList: [{ text: '仅参加此次会议', id: 'only' }, { text: '参加所有会议', id: 'all' }],
      noParticipateStatusList: [{ text: '不参加此次会议', id: 'only' }, { text: '不参加所有会议', id: 'all' }]
    },
    // 传递给组件centerPopup 的数据
    centerPopup: {
      showCenterPopup: false,
      centerPopupList: [
        { id: 0, text: '不发送通知' },
        { id: 1, text: '发送通知' }
      ],
      centerPopupId: ''
    },
    comShareData: comShareData, //来自const.js 只做demo展示，没有实际功能
    title: ``,
    repeatable: 0,
    recurrenceModel: { model: 'no_repeat' },
    isShowRemark: false,
    repeatWeek: ['SU', 'MO', 'TU', 'WE', 'TH', 'FR', 'SA'],
    popupTitle: '会议重复',
    popupShow: false,
    comType: '',
    remark: '',
    comTimeType: '',
    meetingWayModel: { model: null },
    weekList: ['周日', '周一', '周二', '周三', '周四', '周五', '周六'],
    week: '',
    conflictPeople: [],
    isAcrossDay: false,
    scheduleItem: '',
    lock: false,
    aheadTimes: [15],
    organizer: '',
    currentPeople: '',
    editType: '',
    confirmAttendance: null,
    isExpand: false,
    placeholder: '',
    mrReserveStatus: '',
  },
  onShow() {
    console.log(this.$store.data.originUsers)
    console.log(this.$store.data.participatorList)
    // this.conflictPeople()
    // this.store.data.fileInfos = []
    // this.store.data.description = ''
    // this.update()
    setTimeout(() => {
      this.update()
    }, 100)
    if (this.store.data.isNeedReloadList) {
      this.loadAffairList();
      this.setData({
        'conToastData.showToast': true,
        'conToastData.title': '保存成功',
      });
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    }

    if (this.$store.data.updateInfo.isUpate) {
      switch (this.$store.data.updateInfo.updateType) {
        case 'operate_user':
          if (JSON.stringify(this.$store.data.participatorList) !== JSON.stringify(this.$store.data.originUsers)) {
            if (this.data.repeatable === 1) {
              this.setData({
                'conSelectPopupData.selectType': 'common',
                'conSelectPopupData.showSelectPopup': true,
                editType: this.$store.data.updateInfo.updateType
              })
            } else {
              this.isChange(this.$store.data.updateInfo.updateType, 'only')
            }
          } else {
            this.reSetUsers()
            this.$store.data.updateInfo = {
              isUpate: false,
              updateType: ''
            }
          }
          break;
        case 'modify_location':
          if (
            (this.$store.data.locationName !== this.$store.data.originalData.locationName)
            || (this.$store.data.roomId !== this.$store.data.originalData.meetingRoomId)
            || (this.$store.data.startTime != this.$store.data.originalData.startTime)
            || (this.$store.data.endTime != this.$store.data.originalData.endTime)
          ) {
            if (this.data.repeatable === 1) {
              this.setData({
                'conSelectPopupData.selectType': 'common',
                'conSelectPopupData.showSelectPopup': true,
                editType: this.$store.data.updateInfo.updateType
              })
            } else {
              if (this.$store.data.participatorList.length < 2) {
                this.isChange(this.$store.data.updateInfo.updateType, 'only')
              } else {
                this.setData({
                  editType: this.$store.data.updateInfo.updateType,
                  'centerPopup.showCenterPopup': true
                })
              }
              // this.isChange(this.$store.data.updateInfo.updateType, 'only')
            }
          } else {
            this.reSetLocation()
            this.$store.data.updateInfo = {
              isUpate: false,
              updateType: ''
            }
          }
          break;
      }
    }

  },
  onLoad(event) {
    event.scheduleItem = decodeURIComponent(event.scheduleItem);
    this.reset()
    dd.setNavigationBar({
      title: `会议详情`
    })
    this.setData({
      isIPX: checkFullScren(),
      placeholder: `${getApp().globalData.name}创建的会议`,
      scheduleItem: JSON.parse(event.scheduleItem),
      currentPeople: getApp().globalData.userid
    })
    this.getDetail()
    let scheduleItem = this.data.scheduleItem
    const _that = this
    observer.register({
      notice(scheduleItem) {
        _that.setData({
          'scheduleItem.scheduleTemplateId': scheduleItem
        })
      }
    })
  },
  // 获取详情
  getDetail() {
    let data = {
      id: !!this.data.scheduleItem.scheduleId ? this.data.scheduleItem.scheduleId : this.data.scheduleItem.id,
      scheduleTemplateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: !!this.data.scheduleItem.planDate ? this.data.scheduleItem.planDate.replace(/\//g, '-') : null
    }
    getScheduleDetail(data).then(res => {
      if (res.data.code === 0) {
        if (!res.data.data.id) {
          console.log('详情接口scheduleId不存在')
        }
        let participatorList = []
        let originUsers = []
        let originUsersId = []
        let participatorUserId = []
        let repeatListMap = new Map()
        for (let value of res.data.data.userList) {
          if (value.participator) {
            participatorList.push({ userId: value.participator.userId, username: value.participator.username, headUrl: value.participator.headUrl, platform: value.participator.platform })
            participatorUserId.push(value.participator.userId)
            originUsersId.push(value.participator.userId)
            originUsers.push({ userId: value.participator.userId, username: value.participator.username, headUrl: value.participator.headUrl, platform: value.participator.platform })
          }
        }
        for (let item of this.data.comListData.repeatList) {
          if (item.recurrenceModel.recurrenceModel !== 'weekly') {
            repeatListMap.set(item.recurrenceModel.model, item.id)
          }
        }
        this.setData({
          currentPeople: getApp().globalData.userid,
          aheadTimes: !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [],
          'comListData.aheadTimesListId': !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [-1],
          mrReserveStatus: res.data.data.mrReserveStatus,
          confirmAttendance: res.data.data.confirmAttendance === null ? -9 : res.data.data.confirmAttendance,
          organizer: res.data.data.organizer,
          'comListData.meetingWayModelId': res.data.data.meetingWayModel.model === null ? null : (res.data.data.meetingWayModel.model === 'dingtalk' ? 0 : 1),
          repeatable: res.data.data.repeatable,
          recurrenceModel: res.data.data.repeatable ? { model: res.data.data.recurrenceModel.model, daysOfMonth: res.data.data.recurrenceModel.daysOfMonth, interval: 1, initialTime: res.data.data.recurrenceModel.initialTime, terminateTime: res.data.data.recurrenceModel.terminateTime, weekDayList: res.data.data.recurrenceModel.weekDayList } : { model: 'no_repeat' },
          title: res.data.data.title,
          remark: res.data.data.remark,
          isExpand: res.data.data.confirmAttendance === 1 ? true : false,
          isShowRemark: res.data.data.remark ? true : false,
          week: this.data.weekList[new Date(res.data.data.startTime.replace(/-/g, "/")).getDay()],
          getData: true,
          scheduleItem: res.data.data,
          meetingWayModelData: res.data.data.meetingWayModel
        })

        if (res.data.data.repeatable) {
          this.setData({
            'comListData.comSelectListId': res.data.data.recurrenceModel.model === 'weekly' ? (res.data.data.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(res.data.data.recurrenceModel.model),
          })
        }
        this.$store.data.originalData = res.data.data
        this.$store.data.originUsers = originUsers
        this.$store.data.locationName = res.data.data.location.locationName
        this.$store.data.roomId = res.data.data.meetingRoomId < 0 ? '' : res.data.data.meetingRoomId
        this.$store.data.startTime = res.data.data.startTime.replace(/-/g, "/")
        this.$store.data.endTime = res.data.data.endTime.replace(/-/g, "/")
        this.$store.data.participatorList = participatorList
        this.$store.data.participatorUserId = participatorUserId
        this.$store.data.originUsersId = originUsersId
        this.update()
        this.conflictPeople()
        this.store.data.scheduleId = res.data.data.id;
        this.store.data.groupId = res.data.data.groupId;
        this.update();
        this.loadAffairList();
        this.resetRepeatList()
        if (res.data.data.meetingWayModel.model === 'zoom' && res.data.data.meetingWayModel.data === null) {
          setTimeout(() => {
            getScheduleDetail(data).then(success => {
              this.setData({
                meetingWayModelData: res.data.data.meetingWayModel
              })
            })
          }, 30000)
        }
      }
    })
  },
  // 添加描述
  addRemark() {
    this.setData({
      isShowRemark: true
    })
    this.update()

  },
  // 输入框输入事件
  onInput(event) {
    switch (event.target.dataset.type) {
      case 'title':
        this.setData({
          title: event.detail.value
        })
        break
      case 'remark':
        this.setData({
          remark: event.detail.value
        })
        break
    }
  },
  // input 点击换行 时
  onConfirm(event) {
    this.editInput(event)
  },
  // input 失去焦点
  onBlur(event) {
    this.editInput(event)
  },
  // 编辑Input
  editInput(event) {
    switch (event.target.dataset.type) {
      case 'title':
        if (this.data.repeatable) {
          this.isChange('title', 'future')
        } else {
          this.isChange('title', 'only')
        }
        break
      case 'remark':
        if (this.data.repeatable) {
          this.isChange('remark', 'future')
        } else {
          this.isChange('remark', 'only')
        }
        break
    }
  },
  // 初始化
  reset() {
    this.$store.resetEditData()
    this.resetRepeatList()
    this.store.data.affairList = [];
    this.acrossDay(this.$store.data.startTime, this.$store.data.endTime)
  },
  // 跳转下一页
  nextPage(event) {
    const scheduleItem = {
      id: this.data.scheduleItem.id,
      scheduleTemplateId: this.data.scheduleTemplateId,
      planDate: this.data.planDate
    }
    switch (event.target.dataset.nextPage) {
      case 'location':
        this.$store.data.updateInfo.updateType = 'modify_location'
        this.update()
        dd.navigateTo({ url: `./../place/place?scheduleItem=${encodeURIComponent(JSON.stringify(scheduleItem))}&repeatable=${this.data.repeatable}` })
        break
      case 'participantsDetail':
        this.$store.data.updateInfo.updateType = 'operate_user'
        this.update()
        dd.navigateTo({ url: `./../participantsDetail/participantsDetail?scheduleItem=${encodeURIComponent(JSON.stringify(scheduleItem))}` })
        break
    }
  },
  // 所有的关闭操作
  close(event) {
    switch (event.target.dataset.close) {
      case 'location':
        this.$store.data.locationName = ''
        this.$store.data.roomId = ''
        this.update()
        if (this.data.repeatable) {
          this.setData({
            'conSelectPopupData.selectType': 'common',
            'conSelectPopupData.showSelectPopup': true,
            editType: 'modify_location'
          })
        } else {
          if (this.$store.data.participatorList.length < 2) {
            this.isChange('modify_location', 'only')
          } else {
            this.setData({
              editType: 'modify_location',
              'centerPopup.showCenterPopup': true
            })

          }
        }
        break
      case 'meetingWayModel':
        this.setData({
          'comListData.meetingWayModelId': null,
          meetingWayModel: { model: null }
        })
        if (this.data.repeatable) {
          this.isChange('meeting_way', 'future')
        } else {
          this.isChange('meeting_way', 'only')
        }
    }
  },
  // 关闭popup 点击mark
  closePopup() {
    this.setData({
      popupShow: false,
    })
  },
  // 选择循环机制 选择会议方式  选择时间  会前提醒 出现popup弹窗
  showPopup(event) {
    let iconType = ''
    let complete = false
    let multiple = false
    let popupTitle = ''
    switch (event.currentTarget.dataset.type) {
      case 'meetingWayModel':
        iconType = 'image',
          complete = true,
          popupTitle = '选择会议方式',
          multiple = false
        break
      case 'repeat':
        iconType = 'icon',
          popupTitle = '会议重复',
          complete = true,
          multiple = false
        break
      case 'participator':
        popupTitle = '选择参会人'
        break
      case 'time':
        popupTitle = '选择会议时间'
        break
      case 'aheadTime':
        popupTitle = '选择会前提醒'
        iconType = 'icon',
          complete = true,
          multiple = true
        break
    }
    this.setData({
      popupShow: true,
      popupTitle: popupTitle,
      comType: event.currentTarget.dataset.type,
      'comListData.complete': complete,
      'comListData.iconType': iconType,
      'comListData.multiple': multiple
    })
  },
  resetRepeatList() {
    let index = 0
    let repeatList = []
    for (let value of this.data.comListData.repeatList) {
      if (index) {
        value.recurrenceModel.initialTime = this.$store.data.startTime.replace(/\//g, "-").substring(0, 10)
        value.recurrenceModel.terminateTime = this.getTwoYearToday(this.$store.data.startTime)
        if (index === 2) {
          value.recurrenceModel.weekDayList = [this.data.repeatWeek[new Date(this.$store.data.startTime).getDay()]]
        } else if (index === 4) {
          value.recurrenceModel.daysOfMonth = [this.$store.data.startTime.replace(/\//g, "-").substring(8, 10)]
        }
      }
      repeatList.push(value)
      index++
    }
    this.setData({
      'comListData.repeatList': repeatList,
      week: this.data.weekList[new Date(this.$store.data.startTime).getDay()]
    })
  },
  // 选择完comList后的回调 重复 会议方式
  selectComList(event) {
    switch (this.data.comType) {
      case 'meetingWayModel':
        this.setData({
          'comListData.meetingWayModelId': event.currentTarget.dataset.item.id,
          popupShow: false,
          meetingWayModel: this.data.comListData.meetingWayList[event.currentTarget.dataset.item.id].meetingWayModel
        })

        if (this.data.repeatable) {
          this.setData({
            editType: 'meeting_way'
          })
          this.isChange('meeting_way', 'future')
        } else {
          this.isChange('meeting_way', 'only')
        }
        break;
      case 'repeat':
        this.resetRepeatList()
        this.setData({
          popupShow: false,
          'conSelectPopupData.selectType': 'common',
          'comListData.comSelectListId': event.currentTarget.dataset.item.id,
          repeatable: event.currentTarget.dataset.item.repeatable,
          recurrenceModel: event.currentTarget.dataset.item.recurrenceModel
        })
        this.conflictPeople()
        if (this.$store.data.originalData.repeatable) {
          this.setData({
            'conSelectPopupData.showSelectPopup': true,
            editType: 'repeat'
          })
        } else {
          if (this.$store.data.participatorList.length < 2) {
            this.isChange('repeat', 'only')
          } else {
            this.setData({
              editType: 'repeat',
              'centerPopup.showCenterPopup': true
            })
          }

        }
        break;
    }
  },
  // 选择完水平 HList 的回调
  selectComHList(event) {
    switch (event.currentTarget.dataset.item.id) {
      case 0:
        this.addParticipator()
        this.setData({
          popupShow: false
        })
        break;
      case 1:
        this.setData({
          popupShow: false
        })
        const scheduleItem = {
          id: this.data.scheduleItem.id,
          scheduleTemplateId: this.data.scheduleTemplateId,
          planDate: this.data.planDate
        }
        dd.navigateTo({ url: `./../outLookContact/outLookContact?scheduleItem=${JSON.stringify(scheduleItem)}` })
        break;
    }
  },
  // 获取两年后的今天
  getTwoYearToday(startTime) {
    let date = new Date(startTime)
    date.setYear(date.getFullYear() + 2)
    let year = date.getFullYear();
    let month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1;
    let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate()
    return year + '-' + month + '-' + day
  },
  // 添加参会人
  addParticipator() {
    const _that = this
    let require = []
    let select = []
    let outLookConcat = []
    for (let participator of _that.$store.data.participatorList) {
      if (participator.platform === 'outlook') {
        outLookConcat.push(participator)
      }
    }
    if (this.data.organizer === getApp().globalData.userid) {
      select = this.$store.data.participatorUserId
      require = [getApp().globalData.userid]
    } else {
      select = []
      require = [...this.$store.data.originUsersId]
    }
    select = _that.selectedelRequired(require, select).pickedUsers
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      pickedUsers: select, //已选用户
      requiredUsers: require,            //必选用户（不可取消选中状态）
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        let participatorList = []
        let participatorUserId = []
        if (_that.data.organizer === getApp().globalData.userid) {
          participatorList.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' })
          participatorUserId.push(getApp().globalData.userid)
          res.users.forEach((item, index) => {
            participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
            participatorUserId.push(item.userId)
          })
        } else {
          _that.$store.data.originUsers.forEach((item, index) => {
            participatorList.push(item)
            participatorUserId.push(item.userId)
          })
          res.users.forEach((item, index) => {
            participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
            participatorUserId.push(item.userId)
          })
        }
        participatorList = _that.setArrary(participatorList.concat(outLookConcat))
        participatorUserId = [...new Set(participatorUserId)]
        _that.$store.data.participatorList = participatorList
        _that.$store.data.participatorUserId = participatorUserId
        _that.update()
        _that.conflictPeople()
        if (_that.data.repeatable) {
          _that.setData({
            'conSelectPopupData.showSelectPopup': true,
            editType: 'operate_user'
          })
        } else {
          _that.isChange('operate_user', 'only')
        }
      },
      fail: function (err) {
      }
    })
  },
  // 数组 去重
  setArrary(arr) {
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  //  选择时间 点击完成
  onComplete(event) {
    this.$store.data.startTime = `${event.startTime}:00`
    this.$store.data.endTime = `${event.endTime}:00`
    this.update()
    this.acrossDay(this.$store.data.startTime, this.$store.data.endTime)
    this.setData({
      popupShow: false,
      'conSelectPopupData.selectType': 'common',
      week: this.data.weekList[new Date(this.$store.data.startTime).getDay()],
      editType: '',
    })
    this.resetRepeatList()
    if (this.data.repeatable) {
      this.setData({
        'conSelectPopupData.showSelectPopup': true,
        editType: 'modify_time'
      })
    } else {
      if (this.$store.data.participatorList.length < 2) {
        this.isChange('modify_time', 'only')
      } else {
        this.setData({
          editType: 'modify_time',
          'centerPopup.showCenterPopup': true
        })
      }
      // this.isChange('modify_time', 'only')
    }
  },
  // 选择会前提醒时间
  selectAheadtimes(event) {
    this.setData({
      aheadTimes: event,
      popupShow: false,
      'comListData.aheadTimesListId': event
    })
    if (this.data.repeatable) {
      this.setData({
        editType: 'aheadTimes'
      })
      this.isChange('aheadTimes', 'all')
    } else {
      this.isChange('aheadTimes', 'only')
    }
  },
  // 保存编辑
  modifySchedule(data, needNotice = 0) {
    let that = this
    let obj = {
      needNotice: needNotice,
      scheduleId: this.data.scheduleItem.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    return new Promise((resolve, rejects) => {
      modifySchedule(Object.assign(data, obj)).then(res => {
        if (res.data.code === 0) {
          if (data.modifyContent !== 'title') {
            if (this.$store.modifyErpeatMeeting) {
              this.$store.modifyErpeatMeeting()
            }
          }
          if (data.modifyContent == 'modify_time' || data.modifyContent == ' modify_location') {
            this.setData({
              mrReserveStatus: res.data.extra
            })
            this.$store.data.originalData.mrReserveStatus = res.data.extra
            this.update()
          }

          if (this.$store.data.originalData.repeatable === 1 && !!res.data.data) {
            observer.notice(res.data.data)
          }
          return resolve(res)
        } else {
          return rejects(res)
        }
      }).catch(err => {
        return rejects(err)
      })
    })

  },
  // 获取时间参数
  getTimes(time = new Date()) {
    let date = new Date(time)
    let year = date.getFullYear()
    let month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1
    let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate()
    let hour = date.getHours() < 10 ? '0' + date.getHours() : date.getHours()
    let miunutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()
    return `${year}/${month}/${day} ${hour}:${miunutes}:00`
  },
  // 是否跨天
  acrossDay(time1, time2) {
    let isAcrossDay = ''
    if (JSON.stringify(this.getTimes(time1).substring(0, 10)) === JSON.stringify(this.getTimes(time2).substring(0, 10))) {
      isAcrossDay = false
    } else {
      isAcrossDay = true
    }
    this.setData({
      isAcrossDay: isAcrossDay
    })
  },
  // 人员冲突
  conflictPeople() {
    let userIds = []
    for (let value of this.$store.data.participatorList) {
      userIds.push(value.userId)
    }

    let data = {
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      userIds: userIds
    }
    getUserScheduleInTime(data).then(res => {
      let conflictPeople = []
      for (let value in res.data.data) {
        const arr = res.data.data[value].filter(function (item) {
          return item.confirmAttendance === 1
        })
        if (arr.length > 1) {
          conflictPeople.push(value)
        }
      }
      this.setData({
        conflictPeople: conflictPeople
      })
    })
  },
  // toast 消失之后的回调
  onToastHidden() {
    this.setData({
      'conToastData.showToast': false
    })
  },
  // onSelectPopup 选择完的回调
  onSelectPopup(event) {
    const _that = this
    switch (this.data.conSelectPopupData.selectType) {
      case 'common':
        if (this.data.editType === 'modify_location' || this.data.editType === 'modify_time' || this.data.editType === 'repeat') {
          if (this.$store.data.participatorList.length < 2) {
            this.isChange(this.data.editType, event.currentTarget.dataset.item.id)
          } else {
            this.setData({
              'centerPopup.showCenterPopup': true
            })
          }
        } else {
          this.isChange(this.data.editType, event.currentTarget.dataset.item.id)
        }
        break
      case 'noParticipateStatus':
        let data1 = {
          scheduleId: this.data.scheduleItem.id,
          type: event.currentTarget.dataset.item.id,
          templateId: this.data.scheduleItem.scheduleTemplateId,
          planDate: this.data.scheduleItem.planDate,
          value: 0
        }
        isParticipate(data1).then(res => {
          if (res.data.code === 0) {
            this.setData({
              confirmAttendance: 0
            })
            this.conflictPeople()
            if (data1.type === 'only') {
              if (this.$store.modifyOnceMeetingContent) {
                this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: 0 })
              }
            } else {
              if (this.$store.modifyErpeatMeeting) {
                this.$store.modifyErpeatMeeting()
              }
            }
          }
        })
        break
      case 'participateStatus':
        let data = {
          scheduleId: this.data.scheduleItem.id,
          type: event.currentTarget.dataset.item.id,
          templateId: this.data.scheduleItem.scheduleTemplateId,
          planDate: this.data.scheduleItem.planDate,
          value: 1
        }
        isParticipate(data).then(res => {
          if (res.data.code === 0) {
            this.setData({
              aheadTimes: [15],
              'comListData.aheadTimesListId': [15],
              confirmAttendance: 1
            })
            this.conflictPeople()
            if (data.type === 'only') {
              if (this.$store.modifyOnceMeetingContent) {
                this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: 1 })
              }
            } else {
              if (this.$store.modifyErpeatMeeting) {
                this.$store.modifyErpeatMeeting()
              }
            }
          }
        })
        break
      case 'delSheudle':
        dd.confirm({
          title: '删除会议',
          content: '确认删除会议吗？',
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          success: (success) => {
            if (!!success.confirm) {
              dd.showLoading({
                content: '正在删除...',
              });
              let data = {
                scheduleId: this.data.scheduleItem.id,
                identify: this.data.organizer === getApp().globalData.userid ? 'major' : 'identify',
                deleteModel: event.currentTarget.dataset.item.id,
                templateId: this.data.scheduleItem.scheduleTemplateId,
                planDate: this.data.scheduleItem.planDate
              }
              deleteSchedule(data).then(async () => {
                if (this.$store.modifyErpeatMeeting) {
                  await this.$store.modifyErpeatMeeting()
                }
                _that.$store.data.isIndexAffairListNeedUpdate = true;
                _that.update()
                dd.hideLoading()
                dd.navigateBack({
                  delta: 1
                })
              })
            }
          }
        })
        break
    }
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'conSelectPopupData.selectPopupId': event.currentTarget.dataset.item.id
    })
  },
  // 选择发不发通知 
  onSelectSend(event) {
    if (event.currentTarget.dataset.item.id > -1) {
      if (this.$store.data.originalData.repeatable === 1) {
        this.isChange(this.data.editType, this.data.conSelectPopupData.selectPopupId, event.currentTarget.dataset.item.id)
      } else {
        this.isChange(this.data.editType, 'only', event.currentTarget.dataset.item.id)
      }
    } else {
      switch (this.data.editType) {
        case 'operate_user':
          this.reSetUsers()
          break;
        case 'modify_location':
          this.reSetLocation()
          break;
        case 'modify_time':
          this.reSetTime()
          break;
      }
    }
    this.setData({
      'centerPopup.showCenterPopup': false
    })
  },
  // onSelectPopupCancel 点击取消 
  onSelectPopupCancel() {
    this.setData({
      'conSelectPopupData.showSelectPopup': false
    })
    switch (this.data.editType) {
      case 'modify_time':
        this.reSetTime()
        break
      case 'modify_location':
        this.reSetLocation()
        this.$store.data.updateInfo = {
          isUpate: false,
          updateType: ''
        }
        break
      case 'operate_user':
        this.reSetUsers()
        this.$store.data.updateInfo = {
          isUpate: false,
          updateType: ''
        }
        break
      case 'repeat':
        this.reSetRepeat()
        break
    }
  },
  // 重置时间
  reSetTime() {
    this.$store.data.startTime = this.$store.data.originalData.startTime.replace(/-/g, "/")
    this.$store.data.endTime = this.$store.data.originalData.endTime.replace(/-/g, "/")
    this.update()
    this.setData({
      week: this.data.weekList[new Date(this.$store.data.originalData.startTime).getDay()],
    })
  },
  // 重置地点
  reSetLocation() {
    this.$store.data.locationName = this.$store.data.originalData.location.locationName
    this.$store.data.roomId = this.$store.data.originalData.meetingRoomId === -1 ? '' : this.$store.data.originalData.meetingRoomId
    this.update()
  },
  // 重置人物
  reSetUsers() {
    this.$store.data.participatorList = [...this.$store.data.originUsers]
    this.$store.data.participatorUserId = [...this.$store.data.originUsersId]
    this.update()
  },
  // 重置循环
  reSetRepeat() {
    let repeatListMap = new Map()
    for (let item of this.data.comListData.repeatList) {
      if (item.recurrenceModel.recurrenceModel !== 'weekly') {
        repeatListMap.set(item.recurrenceModel.model, item.id)
      }
    }
    this.setData({
      'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
      repeatable: this.$store.data.originalData.repeatable,
      recurrenceModel: this.$store.data.originalData.repeatable ? { model: this.$store.data.originalData.recurrenceModel.model, daysOfMonth: this.$store.data.originalData.recurrenceModel.daysOfMonth, interval: 1, initialTime: this.$store.data.originalData.recurrenceModel.initialTime, terminateTime: this.$store.data.originalData.recurrenceModel.terminateTime, weekDayList: this.$store.data.originalData.recurrenceModel.weekDayList } : { model: 'no_repeat' },
    })
  },
  // 判断数据发生改变 发生改变 请求
  isChange(value, modifyModel, needNotice = 0) {
    let modifyContent = ''
    switch (value) {
      case 'title':
        if (this.data.title !== this.$store.data.originalData.title) {
          let dataTitle = {
            title: this.data.title,
            modifyModel: modifyModel,
            modifyContent: 'title'
          }
          this.modifySchedule(dataTitle).then(res => {
            this.$store.data.isIndexAffairListNeedUpdate = true;
            this.$store.data.originalData.title = this.data.title

            if (this.data.repeatable == 0) {
              if (this.$store.modifyOnceMeetingContent) {
                this.$store.modifyOnceMeetingContent({
                  id: this.data.scheduleItem.id,
                  title: this.data.title
                })
              }
            } else {
              if (this.$store.modifyErpeatMeeting) {
                this.$store.modifyErpeatMeeting()
              }
            }

            this.update()
          }).catch(err => {
            this.setData({
              title: this.$store.data.originalData.title
            })
          })
        }
        break
      case 'remark':
        if (this.data.remark !== this.$store.data.originalData.remark) {
          let dataRemark = {
            remark: this.data.remark,
            modifyModel: modifyModel,
            modifyContent: 'remark'
          }
          this.modifySchedule(dataRemark).then(res => {
            this.$store.data.originalData.remark = this.data.remark
            this.update()
          }).catch(err => {
            this.setData({
              remark: this.$store.data.originalData.remark
            })
          })
        }
        break
      case 'meeting_way':
        let dataWay = {
          meetingWayModel: this.data.meetingWayModel,
          modifyModel: modifyModel,
          modifyContent: 'meeting_way'
        }
        this.modifySchedule(dataWay).then(res => {
          this.$store.data.originalData.meetingWay = !!this.data.comListData.meetingWayModelId ? this.data.comListData.meetingWayList[this.data.comListData.meetingWayModelId] : null
          this.update()
          if (dataWay.meetingWayModel.model === 'zoom' && this.store.data.relatedAppPlatform.includes('zoom')) {
            const scheduleDetailData = {
              id: !!this.data.scheduleItem.scheduleId ? this.data.scheduleItem.scheduleId : this.data.scheduleItem.id,
              scheduleTemplateId: this.data.scheduleItem.scheduleTemplateId,
              planDate: !!this.data.scheduleItem.planDate ? this.data.scheduleItem.planDate.replace(/\//g, '-') : null
            }
            getScheduleDetail(scheduleDetailData).then(success => {
              meetingWayModelData: success.data.data.meetingWayModel
            })
          }
        }).catch(err => {
          this.setData({
            'comListData.meetingWayModelId': this.$store.data.originalData.meetingWayModel === null ? null : (this.$store.data.originalData.meetingWayModel.model === 'dingtalk' ? 0 : 1)
          })
        })
        break
      case 'operate_user':
        if (JSON.stringify(this.$store.data.originUsers) != JSON.stringify(this.$store.data.participatorList)) {
          let addUserList = this.arrayPoor(this.$store.data.originUsers, this.$store.data.participatorList).addUserList
          let deleteUserList = this.arrayPoor(this.$store.data.originUsers, this.$store.data.participatorList).deleteUserList
          let dataUser = {
            addUserList: addUserList,
            deleteUserList: deleteUserList,
            modifyModel: modifyModel,
            modifyContent: 'operate_user'
          }
          this.modifySchedule(dataUser, needNotice).then(res => {
            this.$store.data.originUsers = [...this.$store.data.participatorList]
            this.$store.data.originUsersId = [...this.$store.data.participatorUserId]
            this.$store.data.updateInfo = {
              updateType: '',
              isUpate: false
            }
            this.update()
          }).catch(err => {
            this.$store.data.participatorList = [...this.$store.data.originUsers]
            this.$store.data.participatorUserId = [...this.$store.data.originUsersId]
            this.$store.data.updateInfo = {
              updateType: '',
              isUpate: false
            }
            this.update()
          })
        }

        break
      case 'repeat':
        let repeatListMap = new Map()
        for (let item of this.data.comListData.repeatList) {
          if (item.recurrenceModel.recurrenceModel !== 'weekly') {
            repeatListMap.set(item.recurrenceModel.model, item.id)
          }
        }
        if (this.$store.data.originalData.repeatable === 0 && this.data.repeatable === 1) {
          let dataRepeat1 = {
            startTime: this.$store.data.startTime.replace(/\//g, "-"),
            endTime: this.$store.data.endTime.replace(/\//g, "-"),
            modifyModel: modifyModel,
            modifyContent: 'to_repeat',
            recurrenceModel: this.data.recurrenceModel,
            repeatable: this.data.repeatable
          }
          this.modifySchedule(dataRepeat1).then(res => {
            observer.notice(res.data.data)
            this.$store.data.originalData.recurrenceModel = this.data.recurrenceModel
            this.$store.data.originalData.repeatable = this.data.repeatable
            this.update()
          }).catch(err => {
            this.setData({
              'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
              repeatable: this.$store.data.originalData.repeatable,
              recurrenceModel: this.$store.data.originalData.repeatable ? { model: this.storer.data.originalData.recurrenceModel.model, daysOfMonth: this.$store.data.originalData.recurrenceModel.daysOfMonth, interval: 1, initialTime: this.$store.data.originalData.recurrenceModel.initialTime, terminateTime: this.$store.data.originalData.recurrenceModel.terminateTime, weekDayList: this.$store.data.originalData.recurrenceModel.weekDayList } : { model: 'no_repeat' }
            })
          })
        }
        else if (this.$store.data.originalData.repeatable === 1 && this.data.repeatable === 0) {
          let dataRepeat2 = {
            startTime: this.$store.data.startTime.replace(/\//g, "-"),
            endTime: this.$store.data.endTime.replace(/\//g, "-"),
            modifyModel: modifyModel,
            modifyContent: 'no_repeat',
            recurrenceModel: this.data.recurrenceModel,
            repeatable: this.data.repeatable
          }
          this.modifySchedule(dataRepeat2).then(res => {
            this.$store.data.originalData.recurrenceModel = this.data.recurrenceModel
            this.$store.data.originalData.repeatable = this.data.repeatable
            this.update()
          }).catch(err => {
            this.setData({
              'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
              repeatable: this.$store.data.originalData.repeatable,
              recurrenceModel: this.$store.data.originalData.repeatable ? { model: this.$store.data.originalData.recurrenceModel.model, daysOfMonth: this.$store.data.originalData.recurrenceModel.daysOfMonth, interval: 1, initialTime: this.$store.data.originalData.recurrenceModel.initialTime, terminateTime: this.$store.data.originalData.recurrenceModel.terminateTime, weekDayList: this.$store.data.originalData.recurrenceModel.weekDayList } : { model: 'no_repeat' }
            })
          })
        }
        else {
          let dataRepeat3 = {
            startTime: this.$store.data.startTime.replace(/\//g, "-"),
            endTime: this.$store.data.endTime.replace(/\//g, "-"),
            modifyModel: modifyModel,
            modifyContent: 'change_rule',
            recurrenceModel: this.data.recurrenceModel,
            repeatable: this.data.repeatable
          }
          this.modifySchedule(dataRepeat3).then(res => {
            this.$store.data.originalData.recurrenceModel = this.data.recurrenceModel
            this.$store.data.originalData.repeatable = this.data.repeatable
            this.update()
          }).catch(err => {
            this.setData({
              'comListData.comSelectListId': this.$store.data.originalData.recurrenceModel.model === 'weekly' ? (this.$store.data.originalData.recurrenceModel.weekDayList.length > 1 ? 3 : 2) : repeatListMap.get(this.$store.data.originalData.recurrenceModel.model),
              repeatable: this.$store.data.originalData.repeatable
            })
          })
        }
        break
      case 'modify_location':
        let dataLocation = {
          modifyModel: modifyModel,
          modifyContent: 'modify_location',
          location: {
            longitude: '-999',
            latitude: '-999',
            locationName: this.$store.data.locationName
          },
          meetingRoomId: !!this.$store.data.roomId ? this.$store.data.roomId : -1
        }
        this.modifySchedule(dataLocation, needNotice).then(res => {
          this.$store.data.originalData.location = {
            longitude: '-999',
            latitude: '-999',
            locationName: this.$store.data.locationName
          }
          this.$store.data.originalData.meetingRoomId = this.$store.data.roomId ? -1 : this.$store.data.roomId
          this.$store.data.updateInfo = {
            isUpate: false,
            updateType: ''
          }
          this.update()
          if (this.$store.data.startTime != this.$store.data.originalData.startTime.replace(/-/g, '/') || this.$store.data.endTime != this.$store.data.originalData.endTime.replace(/-/g, '/')) {
            let dat2Time1 = {
              modifyModel: modifyModel,
              startTime: this.$store.data.startTime.replace(/\//g, "-"),
              endTime: this.$store.data.endTime.replace(/\//g, "-"),
              modifyContent: 'modify_time'
            }
            this.isChange('modify_time', modifyModel, needNotice)

          }
        }).catch(err => {
          this.$store.data.locationName = this.$store.data.originalData.location.locationName
          this.$store.data.roomId = this.$store.data.originalData.meetingRoomId
          this.update()
        })
        break
      case 'modify_time':
        let data = {
          modifyModel: modifyModel,
          startTime: this.$store.data.startTime.replace(/\//g, "-"),
          endTime: this.$store.data.endTime.replace(/\//g, "-"),
          modifyContent: 'modify_time'
        }
        this.modifySchedule(data, needNotice).then(res => {
          this.$store.data.originalData.startTime = this.$store.data.startTime.replace(/\//g, "-")
          this.$store.data.originalData.endTime = this.$store.data.endTime.replace(/\//g, "-")
          this.update()
          this.resetRepeatList()
          if (this.data.recurrenceModel.model === 'weekly' && this.data.recurrenceModel.weekDayList.length === 1) {
            let dataRepeat4 = {
              startTime: this.$store.data.startTime.replace(/\//g, "-"),
              endTime: this.$store.data.endTime.replace(/\//g, "-"),
              modifyModel: modifyModel,
              modifyContent: 'change_rule',
              recurrenceModel: this.data.comListData.repeatList[2].recurrenceModel,
              repeatable: this.data.repeatable
            }
            this.modifySchedule(dataRepeat4).then(() => {
              this.setData({
                recurrenceModel: this.data.comListData.repeatList[2].recurrenceModel
              })
            })
          } else if (this.data.recurrenceModel.model === 'absolute_Monthly') {
            let dataRepeat5 = {
              startTime: this.$store.data.startTime.replace(/\//g, "-"),
              endTime: this.$store.data.endTime.replace(/\//g, "-"),
              modifyModel: modifyModel,
              modifyContent: 'change_rule',
              recurrenceModel: this.data.comListData.repeatList[4].recurrenceModel,
              repeatable: this.data.repeatable
            }
            this.modifySchedule(dataRepeat5).then(() => {
              this.setData({
                recurrenceModel: this.data.comListData.repeatList[4].recurrenceModel
              })
            })

          }
          // this.modifySchedule(data, needNotice)
        }).catch(err => {
          this.$store.data.startTime = this.$store.data.originalData.startTime.replace(/-/g, '/')
          this.$store.data.endTime = this.$store.data.originalData.endTime.replace(/-/g, '/')
          this.update()
          this.setData({
            week: this.data.weekList[new Date(this.$store.data.originalData.startTime.replace(/-/g, "/")).getDay()],
          })
        })
        break
      case 'aheadTimes':
        let dataAheadTimes = {
          modifyModel: modifyModel,
          aheadTimes: this.data.aheadTimes,
          modifyContent: 'aheadTimes'
        }
        this.modifySchedule(dataAheadTimes).then(res => {
          this.$store.data.originalData.aheadTimes = (this.data.aheadTimes.length === 0 ? null : this.data.aheadTimes)
          this.update()
        }).catch(err => {
          this.setData({
            aheadTimes: this.$store.data.originalData.aheadTimes
          })
        })
        break
    }
  },
  // 数组取差值 原先的数组与现在的比较 增加与减少
  arrayPoor(origin, now) {
    let originMap = new Map()
    let nowMap = new Map()
    let add = []
    let del = []
    for (let x of origin) {
      originMap.set(x.userId, x)
    }
    for (let x of now) {
      nowMap.set(x.userId, x)
      let status1 = originMap.get(x.userId)
      if (!status1) {
        add.push(x)
      }
    }
    for (let x of origin) {
      let status2 = nowMap.get(x.userId)
      if (!status2) {
        del.push(x)
      }
    }
    return {
      addUserList: add,
      deleteUserList: del
    }
  },
  // 已选用户去中去掉必选用户
  selectedelRequired(req, pic) {
    for (let i = 0; i < req.length; i++) {
      for (let m = 0; m < pic.length; m++) {
        if (req[i] == pic[m]) {
          pic.splice(m, 1)
          m--;
        }
      }
    }
    return {
      requiredUsers: req,
      pickedUsers: pic
    }
  },
  // 删除 日程
  handleDelete() {
    const _that = this
    if (this.data.repeatable) {
      this.setData({
        'conSelectPopupData.selectType': 'delSheudle',
        'conSelectPopupData.showSelectPopup': true
      })
    } else {
      dd.confirm({
        title: '删除会议',
        content: '确认删除会议吗？',
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        success: (success) => {
          if (!!success.confirm) {
            dd.showLoading({
              content: '正在删除...',
            });
            let data = {
              scheduleId: this.data.scheduleItem.id,
              identify: this.data.organizer === getApp().globalData.userid ? 'major' : 'identify',
              deleteModel: 'only'
            }
            deleteSchedule(data).then(async () => {

              if (this.$store.modifyErpeatMeeting) {
                await this.$store.modifyErpeatMeeting()
              }
              _that.$store.data.isIndexAffairListNeedUpdate = true;
              _that.update()
              dd.hideLoading()
              dd.navigateBack({
                delta: 1
              })
            })
          }
        }
      })
    }
  },
  // 点击参加
  participate() {
    let data = {
      scheduleId: this.data.scheduleItem.id,
      value: 1,
      type: 'only'
    }
    if (this.data.repeatable) {
      this.setData({
        'conSelectPopupData.showSelectPopup': true,
        'conSelectPopupData.selectType': 'participateStatus'
      })
    } else {
      isParticipate(data).then(res => {
        if (res.data.code === 0) {
          this.setData({
            aheadTimes: [15],
            'comListData.aheadTimesListId': [15],
            confirmAttendance: 1
          })
          this.conflictPeople()
          if (this.$store.modifyOnceMeetingContent) {
            this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: 1 })
          }
        }
      })
    }
  },
  // 点击 不参加
  noParticipate() {
    let data = {
      scheduleId: this.data.scheduleItem.id,
      value: 0,
      type: 'only'
    }
    if (this.data.repeatable) {
      this.setData({
        'conSelectPopupData.showSelectPopup': true,
        'conSelectPopupData.selectType': 'noParticipateStatus'
      })
    } else {
      isParticipate(data).then(res => {
        if (res.data.code === 0) {
          this.setData({
            confirmAttendance: 0
          })
          this.conflictPeople()
          if (this.$store.modifyOnceMeetingContent) {
            this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: 0 })
          }
        }
      })
    }
  },
  initialState() {
    let data = {
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate,
      scheduleId: this.data.scheduleItem.id,
      value: -9,
      type: 'only'
    }
    if (this.data.repeatable === 1) {
      data.type = 'all'

    } else {
      data.type = 'only'
    }
    isParticipate(data).then(res => {
      if (res.data.code === 0) {
        this.setData({
          confirmAttendance: -9
        })
        this.conflictPeople()
        if (this.data.repeatable === 1) {
          if (this.$store.modifyErpeatMeeting) {
            this.$store.modifyErpeatMeeting()
          }
        } else {
          if (this.$store.modifyOnceMeetingContent) {
            this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: -9 })
          }
        }

      }
    })
  },
  // 页面卸载
  onUnload() {
    // 页面被关闭
    observer.unregister()
  },

  //获取动态列表
  loadAffairList(current = 1) {
    if (this.data.repeatable == 1) {
      if (!this.data.scheduleItem.groupId) {
        console.log(`groupId不存在`)
        return
      }
      this.getRepeatAffairList(this.data.scheduleItem.groupId, current)
    } else {
      if (!this.data.scheduleItem.id) {
        console.log(`scheduleItem.id不存在`)
        return
      }
      this.getAffairList(this.data.scheduleItem.id)
    }
    //重置
    this.store.data.isNeedReloadList = false;
    this.update();

  },
  //获取单次会议动态列表
  getAffairList(id) {
    getMeetingRoomAffairs(id).then(res => {
      const newAffairList = this.dealAffairData(res.data.data || []);
      this.store.data.affairList = newAffairList;
      this.update();
      this.setData({
        affairLoading: false
      });
    })
  },
  //获取重复会议动态列表
  getRepeatAffairList(groupId, current) {
    getMeetingRoomRepeatAffairs(groupId, current).then(res => {
      const newAffairList = this.dealRepeatAffairs(res.data.data.records || []);
      //第一页数据会重新请求需要替换
      if (current === 1) {
        this.store.data.affairList = newAffairList;
        this.update();
      } else {
        const newDynamicList = this.store.data.affairList.concat(newAffairList);
        this.store.data.affairList = newDynamicList;
        this.update();
      }
      this.setData({
        affairLoading: false,
        current: res.data.data.current,
        pages: res.data.data.pages
      });
    })
  },
  //加载之前的会议动态
  loadAffairMore() {
    if (this.data.current < this.data.pages) {
      this.loadAffairList(this.data.current + 1);
    }
  },
  //处理重复会议动态数据
  dealRepeatAffairs(affairList, type) {
    // const newAffairData = {};
    // const newAffairList = [];
    // affairList.forEach(it => {
    //   if (it.meetingLogResource) {
    //     newAffairData[it.resourceId] = []
    //   }
    // })
    return affairList.map(item => {
      let itemData = item.meetingLogResource;
      if (itemData) {
        if (item.createTime) {
          item.sort1 = item.createTime
          item.sort = new Date(item.createTime.replace(/-/g, '/')).getTime();
          item.createTime = getCreateShowTime(item.createTime);
        }
        if (itemData.acceptorInfo) {
          itemData.acceptorInfo = JSON.parse(itemData.acceptorInfo);
        }
        if (itemData.creatorInfo) {
          itemData.creatorInfo = JSON.parse(itemData.creatorInfo);
        }
        if (itemData.fileInfos) {
          item.fileView = {
            fileInfos: JSON.parse(itemData.fileInfos),
            creatorInfo: itemData.creatorInfo,
            id: itemData.id,
            description: itemData.description
          };
        }
        if (itemData.taskInfos) {
          item.taskViewList = [
            {
              acceptorInfo: itemData.acceptorInfo,
              acceptorId: itemData.acceptorId,
              creatorInfo: itemData.creatorInfo,
              creatorId: itemData.creatorId,
              taskInfos: JSON.parse(itemData.taskInfos),
              taskStatus: itemData.taskStatus,
              id: itemData.id
            }
          ]
        }

        // newAffairData[item.resourceId].push(item);
      }
      return item
    });
    // console.log(newAffairData);
    // for (let i in newAffairData) {
    //   newAffairData[i].sort((a, b) => a.sort - b.sort);
    //   newAffairList.push(newAffairData[i][0])
    // }
    // console.log(newAffairList)
    // return newAffairList.sort((a, b) => a.sort - b.sort);
  },
  //处理会议动态数据
  dealAffairData(affairList) {
    return affairList.map(it => {
      if (it.createTime) {
        it.createTime = getCreateShowTime(it.createTime);
      }
      if (it.category == '2' && it.fileView) {
        if (it.fileView.creatorInfo) {
          it.fileView.creatorInfo = JSON.parse(it.fileView.creatorInfo);
        }
        if (it.fileView.fileInfos) {
          it.fileView.fileInfos = JSON.parse(it.fileView.fileInfos)
        }
        return it
      }
      else if (it.category === '3' && it.taskViewList) {
        it.taskViewList.map(o => {
          if (o.acceptorInfo) {
            o.acceptorInfo = JSON.parse(o.acceptorInfo)
          }
          if (o.creatorInfo) {
            o.creatorInfo = JSON.parse(o.creatorInfo)
          }
          if (o.taskInfos) {
            o.taskInfos = JSON.parse(o.taskInfos)
          }
          return o
        })
        return it
      }
      return it
    })
  },
  showPop(e) {
    this.setData({
      pop: e.target.dataset.pop,
      show: true
    })
  },
  closePop() {
    this.setData({
      show: false
    });

    if (this.data.pop.type == 'updateTask') {
      const { currentTask } = this.store.data;
      const { oldTask } = this.data;

      //添加执行人
      if (!oldTask.acceptorId && currentTask.acceptorId) {
        this.addTaskExcutor();
      }
      ///删除执行人
      else if (oldTask.acceptorId && !currentTask.acceptorId) {
        this.deleteTaskExcutor();
      }
      //修改执行人
      else if ((oldTask.acceptorId && currentTask.acceptorId) && (oldTask.acceptorId !== currentTask.acceptorId)) {
        this.updateTaskExcutor();
      }
      //修改任务标题
      if (currentTask.taskInfos.taskTitle && currentTask.taskInfos.taskTitle !== oldTask.taskInfos.taskTitle) {
        this.editTaskTitle();
      }
      //修改任务状态
      if (currentTask.taskStatus !== oldTask.taskStatus) {
        this.changeTaskStatus();
      }

      //刷新列表,这里为什么不在promie后执行
      setTimeout(() => {
        if (this.store.data.isNeedReloadList) {
          this.loadAffairList();
          this.setData({
            'conToastData.showToast': true,
            'conToastData.title': '编辑成功',
          })
          this.$store.data.isIndexAffairListNeedUpdate = true;
          this.update();
        }
      }, 500)
    }
  },
  //出现任务弹窗
  showCreateTask(e) {
    //重置
    this.store.data.currentTask = {};
    this.update();
    this.showPop(e)
  },
  //设置修改任务弹框中当前任务
  setCurrentTask(currentTask) {
    this.setData({
      oldTask: JSON.parse(JSON.stringify(currentTask))
    })
    this.store.data.currentTask = currentTask;
    this.update();
  },
  // 添加文件
  addMeetingFile() {
    //重置
    this.setData({
      loading: true
    })
    this.store.data.description = '';
    this.store.data.fileInfos = null;
    let data = {
      ddUserId: getApp().globalData.userid,
      type: 'add',
      projectName: 'MING_MEETING'
    }
    uploadPermissions(data).then(res => {
      if (res.data.code === 0) {
        this.setData({
          loading: false
        })
        dd.uploadAttachmentToDingTalk({
          image: { multiple: true, compress: true, max: 9, spaceId: res.data.data },
          space: { spaceId: res.data.data, compress: true, isCopy: 1, max: 9 },
          types: ["photo", "camera", "space"],
          success: (res) => {
            this.store.data.fileInfos = res.data;
            dd.navigateTo({ url: `./../uploadFile/uploadFile` })
          },
          fail: (err) => {
          }
        })
      }
    })
  },
  // 上传oss文件
  async addOssFile() {
    this.store.data.description = '';
    this.store.data.fileInfos = null;
    const res = await getFileInfoFromOss();
    if (res.code === -1) {
      dd.alert({
        content: res.msg,
        buttonText: '确定'
      })
      return
    }
    this.store.data.fileInfos = res.data
    this.update()
    dd.navigateTo({ url: `./../uploadFile/uploadFile` })
  },

  //隐藏文件操作浮窗
  hideFileOperate() {
    this.store.data.logId = '';
    this.update();
  },
  // 删除文件
  deleteMeetingFile(id) {
    this.updateTask({
      "logType": "schedule_accessory_remove",
      "resourceType": "accessory",
      "id": id
    }, () => {
      this.loadAffairList();
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    })
  },
  // 删除执行人
  deleteTaskExcutor() {
    this.updateTask({
      "logType": "task_remove_acceptor",
      acceptorInfo: JSON.stringify(this.data.oldTask.acceptorInfo),
      acceptorId: this.data.oldTask.acceptorId
    })
  },
  // 添加执行人
  addTaskExcutor() {
    this.updateTask({
      "logType": "task_add_acceptor",
      acceptorInfo: JSON.stringify(this.store.data.currentTask.acceptorInfo),
      acceptorId: this.store.data.currentTask.acceptorId
    })
  },
  //修改执行人
  updateTaskExcutor() {
    this.updateTask({
      "logType": "task_modify_acceptor",
      acceptorInfo: JSON.stringify(this.store.data.currentTask.acceptorInfo),
      acceptorId: this.store.data.currentTask.acceptorId
    })
  },
  //修改任务标题
  editTaskTitle(value) {
    this.updateTask({
      "logType": "task_modify_title",
      "taskInfos": JSON.stringify(this.store.data.currentTask.taskInfos)
    })
  },
  //重复任务状态处理
  dealRepeatStatus(task) {
    let dataIndex = "";
    this.data.affairList.forEach((item, index) => {
      if (item.meetingLogResource.id == task.id) {
        dataIndex = index;
      }
    });
    const setData = `affairList[${dataIndex}].taskViewList[0].taskStatus`;
    const setData2 = `affairList[${dataIndex}].meetingLogResource.taskStatus`;

    this.store.data[setData] = task.status;
    this.store.data[setData2] = task.status;
    this.update();
  },
  //列表修改任务状态
  changeTaskStatusOnList(task) {
    this.updateTask({
      "logType": "task_status_modify",
      "taskStatus": task.status,
      'id': task.id
    }, () => {
      if (this.data.repeatable == 1) {
        this.dealRepeatStatus(task);
      } else {
        this.loadAffairList();
      }
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    })
  },
  //弹窗修改任务状态
  changeTaskStatus() {
    this.updateTask({
      "logType": "task_status_modify",
      "taskStatus": this.store.data.currentTask.taskStatus
    }, () => {
      if (this.data.repeatable == 1) {
        this.dealRepeatStatus({ status: this.store.data.currentTask.taskStatus, id: this.store.data.currentTask.id });
      }
      this.store.data.isNeedReloadList = true;
      this.update();
    })
  },
  //删除任务
  deleteTask(id) {
    this.updateTask({
      "logType": "task_remove",
    }, () => {
      this.closePop();
      this.loadAffairList();
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    })
  },
  //修改任务
  updateTask(taskData, callBack) {
    const postData = {
      "groupId": this.data.scheduleItem.groupId,
      "scheduleId": this.data.scheduleItem.id,
      "resourceType": "task",
      "creatorId": getApp().globalData.userid,
      "creatorInfo": getApp().globalData.userInfo,
      "id": this.store.data.currentTask.id,
      ...taskData
    }
    updateMeetingTask(postData).then(res => {
      if (res.data.code == 0) {
        if (callBack) {
          callBack();
        } else {
          this.store.data.isNeedReloadList = true;
          this.update();
        }
      }
    })
  },
  //创建任务
  complete: throttle(function () {
    const { currentTask } = this.store.data;
    const postData = {
      "groupId": this.data.scheduleItem.groupId,
      "scheduleId": this.data.scheduleItem.id,
      "resourceType": "task",
      "creatorId": getApp().globalData.userid,
      "creatorInfo": getApp().globalData.userInfo,
      "logType": "task_add",
      "taskInfos": JSON.stringify(currentTask.taskInfos),
      "taskStatus": '0',
      "description": ""
    }
    if (currentTask.acceptorId) {
      postData.acceptorId = currentTask.acceptorId;
      postData.acceptorInfo = JSON.stringify(currentTask.acceptorInfo);
    }
    createMeetingTask(postData).then(res => {
      if (res.data.code == 0) {
        this.loadAffairList();
        this.closePop();
        this.setData({
          'conToastData.showToast': true,
          'conToastData.title': '保存成功',
        })
        //重置
        this.store.data.currentTask = {};
        this.update();

        this.$store.data.isIndexAffairListNeedUpdate = true;
        this.update();
      }
    })
  }),
  expand() {
    this.setData({
      isExpand: false
    })
  },
  onShareAppMessage() {
    this.setData({
      'comShareData.isShow': true
    })
    // this.data.comShareData.isShow = true
    // return {
    //   type: 1, //分享类型，0:全部组件 默认； 1:只能分享到钉钉；2:不能分享，只有刷新按钮
    //   control: true,
    //   title: '智能会议室',
    //   desc: '会议详情',
    //   path: 'pages/index/index'
    // };
  },
  closeShare() {
    this.setData({
      'comShareData.isShow': false
    })
  },
  setCopy(event) {
    if (event.currentTarget.dataset.type) {
      dd.setClipboard({
        text: event.currentTarget.dataset.item,
        success: res => {
          dd.alert({
            buttonText: '确定',
            content: '复制成功，请在外部浏览器打开'
          })
        }
      })
    } else {
      dd.setClipboard({
        text: event.currentTarget.dataset.item,
        success: res => {
          this.setData({
            'conToastData.showToast': true,
            'conToastData.title': '复制成功',
          });

        }
      })
    }
  }
});

