import { getRndInteger } from '../../utils/utils.js'
import { getOssPermission } from '../../api/request.js'
import { saveFileInfo, getMeetingRoomAffairs, createMeetingTask, deleteMeetingTask, updateMeetingTask, uploadPermissions } from '../../api/request';
import pageStore from './store'

// 选择图片
function getImg() {
    return new Promise((resolve, rejects) => {
        dd.chooseImage({
            count: 1,
            success: (res) => {
                if (res.files[0].size > 20 * 1024 * 1024) {
                    rejects({ code: -1, msg: '文件小一点', ...res })
                } else {
                    resolve(res)
                }
            },
            fail: (err) => {
                rejects({ code: -1, msg: '选择图片失败', ...err })
            }
        });
    })
}

// 获取的图片上传到oss
async function uploadImg(imgInfo) {
    const permisson = await getOssPermission()
    const timestamp = new Date().getTime()
    const random = getRndInteger(1000, 10000)
    const fileName = timestamp.toString() + random.toString() + '.' + imgInfo.files[0].fileType;
    const key = permisson.data.data.dir + fileName;
    return new Promise((resolve, rejects) => {
        dd.uploadFile({
            url: permisson.data.data.host,
            fileType: 'image',
            fileName: 'file',
            filePath: imgInfo.filePaths[0],
            formData: {
                key: key,
                policy: permisson.data.data.policy,
                OSSAccessKeyId: permisson.data.data.accessId,
                success_action_status: 200,
                signature: permisson.data.data.signature
            },
            success: (res) => {
                resolve([{
                    fileId: key,
                    fileName: fileName,
                    fileType: imgInfo.files[0].fileType,
                    fileSize: imgInfo.files[0].size
                }])
            },
            fail: (err) => {
                rejects({ code: -1, msg: '选上传图片失败', ...err })
            }
        })
    })
}
// 从OSS获取fileInfo
export async function getFileInfoFromOss() {
    try {
        const imgInfo = await getImg();
        dd.showLoading({
            content: '正在上传...',
        });
        const fileInfo = await uploadImg(imgInfo);
        dd.hideLoading()
        return { code: 0, msg: 'success', data: fileInfo }
    } catch (err) {
        dd.hideLoading()
        return err
    }
}